image: java:8
stages:
  - build
  - deploy
build:
  stage: build
  before_script:
    - cd backend
  script:
    - ./mvnw clean package
  artifacts:
    paths: 
      - backend/target/service-0.0.1-SNAPSHOT.jar
    
deploy:
  stage: deploy
  before_script:
    - 'which ssh-agent || ( apt-get install -qq openssh-client )'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh
    - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - 'scp ./backend/target/service-0.0.1-SNAPSHOT.jar $DEPLOY_USER@$DEPLOY_SERVER:/var/icb/icb.jar'
    - 'ssh $DEPLOY_USER@$DEPLOY_SERVER "sudo systemctl daemon-reload && sudo systemctl restart icb.service"'
  only:
    - /^release/.*$/